# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AccessGroup(pydantic.BaseModel):
    id: typing.Optional[str] = pydantic.Field(alias="_id", description="Unique identifier for the Access Group")
    name: typing.Optional[str] = pydantic.Field(description="Name of the the Access Group")
    short_id: typing.Optional[str] = pydantic.Field(
        alias="shortId",
        description="Shortened unique identifier based on name, optimized for its use in the user’s JWT",
    )
    slug: typing.Optional[str] = pydantic.Field(
        description="Shortened unique identifier based on name, optimized for human readability and public API use"
    )
    created_on: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdOn", description="The date the Access Group was created"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
