# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AuthorizationAuthorizationAuthorizedTo(pydantic.BaseModel):
    site_ids: typing.Optional[typing.List[typing.Any]] = pydantic.Field(
        alias="siteIds", description="Array of Sites this app is authorized to"
    )
    workspace_ids: typing.Optional[typing.List[typing.Any]] = pydantic.Field(
        alias="workspaceIds", description="Array of Workspaces this app is authorized to"
    )
    user_ids: typing.Optional[typing.List[typing.Any]] = pydantic.Field(
        alias="userIds", description="Array of Users this app is authorized to"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
