# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CollectionListArrayItem(pydantic.BaseModel):
    """
    A collection object
    """

    id: str = pydantic.Field(description="Unique identifier for a Collection")
    display_name: typing.Optional[str] = pydantic.Field(alias="displayName", description="Name given to the Collection")
    singular_name: typing.Optional[str] = pydantic.Field(
        alias="singularName",
        description="The name of one Item in Collection (e.g. ”Blog Post” if the Collection is called “Blog Posts”)",
    )
    slug: typing.Optional[str] = pydantic.Field(description="Slug of Collection in Site URL structure")
    created_on: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdOn", description="The date the collection was created"
    )
    last_updated: typing.Optional[dt.datetime] = pydantic.Field(
        alias="lastUpdated", description="The date the collection was last updated"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
