# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CustomCodeResponse(pydantic.BaseModel):
    """
    Registered custom code for application
    """

    id: typing.Optional[str] = pydantic.Field(
        description="Human readable id, derived from the user-specified display name"
    )
    created_on: typing.Optional[str] = pydantic.Field(
        alias="createdOn", description="Timestamp when the script version was created"
    )
    last_updated: typing.Optional[str] = pydantic.Field(
        alias="lastUpdated", description="Timestamp when the script version was last updated"
    )
    hosted_location: typing.Optional[str] = pydantic.Field(
        alias="hostedLocation", description="URI for an externally hosted script location"
    )
    integrity_hash: typing.Optional[str] = pydantic.Field(
        alias="integrityHash",
        description="Sub-Resource Integrity Hash. Only required for externally hosted scripts (passed via hostedLocation)",
    )
    can_copy: typing.Optional[bool] = pydantic.Field(
        alias="canCopy", description="Define whether the script can be copied on site duplication and transfer"
    )
    version: typing.Optional[str] = pydantic.Field(
        description="A Semantic Version (SemVer) string, denoting the version of the script"
    )
    display_name: typing.Optional[str] = pydantic.Field(
        alias="displayName", description="User-facing name for the script"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
