# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EcommerceSettings(pydantic.BaseModel):
    """
    Ecommerce settings for a Webflow Site
    """

    site_id: typing.Optional[str] = pydantic.Field(alias="siteId", description="The identifier of the Site")
    created_on: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdOn", description="Date that the Site was created on"
    )
    default_currency: typing.Optional[str] = pydantic.Field(
        alias="defaultCurrency", description="The three-letter ISO currency code for the Site"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
