# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class FieldType(str, enum.Enum):
    """
    Choose these appropriate field type for your collection data
    """

    PLAIN_TEXT = "PlainText"
    RICH_TEXT = "RichText"
    IMAGE = "Image"
    MULTI_IMAGE = "MultiImage"
    VIDEO = "Video"
    LINK = "Link"
    EMAIL = "Email"
    PHONE = "Phone"
    NUMBER = "Number"
    DATE_TIME = "DateTime"
    BOOLEAN = "Boolean"
    COLOR = "Color"
    EXT_FILE_REF = "ExtFileRef"

    def visit(
        self,
        plain_text: typing.Callable[[], T_Result],
        rich_text: typing.Callable[[], T_Result],
        image: typing.Callable[[], T_Result],
        multi_image: typing.Callable[[], T_Result],
        video: typing.Callable[[], T_Result],
        link: typing.Callable[[], T_Result],
        email: typing.Callable[[], T_Result],
        phone: typing.Callable[[], T_Result],
        number: typing.Callable[[], T_Result],
        date_time: typing.Callable[[], T_Result],
        boolean: typing.Callable[[], T_Result],
        color: typing.Callable[[], T_Result],
        ext_file_ref: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is FieldType.PLAIN_TEXT:
            return plain_text()
        if self is FieldType.RICH_TEXT:
            return rich_text()
        if self is FieldType.IMAGE:
            return image()
        if self is FieldType.MULTI_IMAGE:
            return multi_image()
        if self is FieldType.VIDEO:
            return video()
        if self is FieldType.LINK:
            return link()
        if self is FieldType.EMAIL:
            return email()
        if self is FieldType.PHONE:
            return phone()
        if self is FieldType.NUMBER:
            return number()
        if self is FieldType.DATE_TIME:
            return date_time()
        if self is FieldType.BOOLEAN:
            return boolean()
        if self is FieldType.COLOR:
            return color()
        if self is FieldType.EXT_FILE_REF:
            return ext_file_ref()
