# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .order_address_japan_type import OrderAddressJapanType
from .order_address_type import OrderAddressType

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class OrderAddress(pydantic.BaseModel):
    """
    A customer address
    """

    type: typing.Optional[OrderAddressType] = pydantic.Field(
        description="The type of the order address (billing or shipping)"
    )
    japan_type: typing.Optional[OrderAddressJapanType] = pydantic.Field(
        alias="japanType", description="Japan-only address format"
    )
    addressee: typing.Optional[str] = pydantic.Field(description="Display name on the address")
    line_1: typing.Optional[str] = pydantic.Field(alias="line1", description="The first line of the address")
    line_2: typing.Optional[str] = pydantic.Field(alias="line2", description="The second line of the address")
    city: typing.Optional[str] = pydantic.Field(description="The city of the address.")
    state: typing.Optional[str] = pydantic.Field(description="The state or province of the address")
    country: typing.Optional[str] = pydantic.Field(description="The country of the address")
    postal_code: typing.Optional[str] = pydantic.Field(alias="postalCode", description="The postal code of the address")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
