# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .order_price import OrderPrice
from .order_totals_extras_item import OrderTotalsExtrasItem

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class OrderTotals(pydantic.BaseModel):
    """
    An object describing various pricing totals
    """

    subtotal: typing.Optional[OrderPrice] = pydantic.Field(description="The subtotal price")
    extras: typing.Optional[typing.List[OrderTotalsExtrasItem]] = pydantic.Field(
        description="An array of extra items, includes discounts, shipping, and taxes."
    )
    total: typing.Optional[OrderPrice] = pydantic.Field(description="The total price")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
