# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .page_seo_graph_data_open_graph import PageSeoGraphDataOpenGraph
from .page_seo_graph_data_seo import PageSeoGraphDataSeo

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class PageSeoGraphData(pydantic.BaseModel):
    """
    The SEO and/or OpenGraph information to include in the page's details
    """

    seo: typing.Optional[PageSeoGraphDataSeo]
    open_graph: typing.Optional[PageSeoGraphDataOpenGraph] = pydantic.Field(alias="openGraph")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
