# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .sku_property_list import SkuPropertyList

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ProductFieldData(pydantic.BaseModel):
    name: typing.Optional[str] = pydantic.Field(description="Name of the Product")
    slug: typing.Optional[str] = pydantic.Field(description="URL structure of the Product in your site.")
    sku_properties: typing.Optional[typing.List[SkuPropertyList]] = pydantic.Field(
        alias="sku-properties", description="Variant/Options types to include in SKUs"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
