# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .domain import Domain

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Site(pydantic.BaseModel):
    id: str = pydantic.Field(description="Unique identifier for the Site")
    workspace_id: typing.Optional[str] = pydantic.Field(
        alias="workspaceId", description="Unique identifier for the Workspace"
    )
    created_on: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdOn", description="Date the Site was created"
    )
    display_name: typing.Optional[str] = pydantic.Field(alias="displayName", description="Name given to Site")
    short_name: typing.Optional[str] = pydantic.Field(alias="shortName", description="Slugified version of name")
    last_published: typing.Optional[dt.datetime] = pydantic.Field(
        alias="lastPublished", description="Date the Site was last published"
    )
    last_updated: typing.Optional[dt.datetime] = pydantic.Field(
        alias="lastUpdated", description="Date the Site was last updated"
    )
    preview_url: typing.Optional[str] = pydantic.Field(
        alias="previewUrl", description="URL of a generated image for the given Site"
    )
    time_zone: typing.Optional[str] = pydantic.Field(
        alias="timeZone", description="Site timezone set under Site Settings"
    )
    custom_domains: typing.Optional[typing.List[Domain]] = pydantic.Field(alias="customDomains")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
