# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class StripeDetails(pydantic.BaseModel):
    """
    An object with various Stripe IDs, useful for linking into the stripe dashboard.
    """

    subscription_id: typing.Optional[str] = pydantic.Field(
        alias="subscriptionId", description="Stripe-generated identifier for the Subscription"
    )
    payment_method: typing.Optional[str] = pydantic.Field(
        alias="paymentMethod", description="Stripe-generated identifier for the PaymentMethod used"
    )
    payment_intent_id: typing.Optional[str] = pydantic.Field(
        alias="paymentIntentId", description="Stripe-generated identifier for the PaymentIntent, or null"
    )
    customer_id: typing.Optional[str] = pydantic.Field(
        alias="customerId", description="Stripe-generated customer identifier, or null"
    )
    charge_id: typing.Optional[str] = pydantic.Field(
        alias="chargeId", description="Stripe-generated charge identifier, or null"
    )
    dispute_id: typing.Optional[str] = pydantic.Field(
        alias="disputeId", description="Stripe-generated dispute identifier, or null"
    )
    refund_id: typing.Optional[str] = pydantic.Field(
        alias="refundId", description="Stripe-generated refund identifier, or null"
    )
    refund_reason: typing.Optional[str] = pydantic.Field(
        alias="refundReason", description="Stripe-generated refund reason, or null"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
