# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class SitePublishPayload(pydantic.BaseModel):
    """
    The payload of data sent from Webflow
    """

    site: typing.Optional[str] = pydantic.Field(description="The site id that was published")
    publish_time: typing.Optional[dt.datetime] = pydantic.Field(
        alias="publishTime", description="The timestamp of the publish event"
    )
    domains: typing.Optional[typing.List[str]] = pydantic.Field(description="The domains that were published")
    published_by: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        alias="publishedBy", description="The name and id of the user who published the site"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
